///////////////////////////////////////////////////////////
////// GibPascal pascal_web.c
////// Released under the GPLv3
////// Written by:
//////    Michael Gibson
//////    (c)2003-2021
///////////////////////////////////////////////////////////

#include <string.h>
#include <stdio.h>

char variable_names[256][256];
char variable_type[256];
char value_of_variables[256][256];


/////////////////////////////////////////////////////////
////// query_remote_web_client
////// used for trouble shooting web environment variables
////////////////////////////////////////////////////////////
void query_remote_web_client()
{
  printf("HTTP_USER_AGENT=%s<br>\n",getenv("HTTP_USER_AGENT"));
  printf("REMOTE_ADDR=%s<br>\n",getenv("REMOTE_ADDR"));
  printf("REQUEST_METHOD=%s<br>\n",getenv("REQUEST_METHOD"));
  printf("QUERY_STRING=%s<br>\n",getenv("QUERY_STRING"));
  printf("CONTENT_LENGTH=%s<br>\n",getenv("CONTENT_LENGTH"));
}


//////////////////////////////////////////////////////////////////////
////// writewh()
////// writes default web header
/////////////////////////////////////////////////////////////////////
void g_pascal_writewh(){

  printf("Content-type: text/html\n\n");

}
///////////////////////////////////////////////////////////////////////
////// echo_wc();
////// 
////// Not a direct command called function, but used by other functions
///////////////////////////////////////////////////////////////////////
void echo_wc(int spch)
{

  if(spch==1) printf("&nbsp;");
  if(spch==2) printf("&lt;");
  if(spch==3) printf("&gt;");
  if(spch==4) printf("&amp;");
  if(spch==5) printf("&quot;");

}

////////////////////////////////////////////////////////
////// read_http_user_agent()
////////////////////////////////////////////////////////
void read_http_user_agent(char *stread,int indent)
{
  char temptext[50], tempstr[256];
  int loop=0, loop2=0;

  loop=indent;
  do{
    if( stread[loop] != ')' ){
       tempstr[loop2]=stread[loop];
       loop++;
       loop2++;
    }
  }while ( stread[loop] != ')' );
  tempstr[loop2]='\0';

  for(loop=0;loop<256;loop++){
    if( strcmp(tempstr,variable_names[loop])==0) break;
  }
  sprintf(temptext,"%s",getenv("HTTP_USER_AGENT"));
  strcpy(value_of_variables[loop],temptext);
}

/////////////////////////////////////////////////
//////  read_content_length()
///////////////////////////////////////////////////
void read_content_length(char *stread, int indent)
{
  char temptext[60], tempstr[256];
  int loop=0, loop2=0;

  loop=indent;
  do{
    if( stread[loop] != ')' ){
       tempstr[loop2]=stread[loop];
       loop++;
       loop2++;
    }
  }while ( stread[loop] != ')' );
  tempstr[loop2]='\0';

  for(loop=0;loop<256;loop++){
    if( strcmp(tempstr,variable_names[loop])==0) break;
  }
  sprintf(temptext,"%s",getenv("CONTENT_LENGTH"));
  strcpy(value_of_variables[loop],temptext);
}

//////////////////////////////////////////////////
////// read_query_string()
/////////////////////////////////////////////////
void read_query_string(char *stread, int indent)
{
  char temptext[50], tempstr[256];
  int loop=0, loop2=0;

  loop=indent;
  do{
    if( stread[loop] != ')' ){
       tempstr[loop2]=stread[loop];
       loop++;
       loop2++;
    }
  }while ( stread[loop] != ')' );
  tempstr[loop2]='\0';

  for(loop=0;loop<256;loop++){
    if( strcmp(tempstr,variable_names[loop])==0) break;
  }
  sprintf(temptext,"%s",getenv("QUERY_STRING") );
  strcpy(value_of_variables[loop],temptext);

}

/////////////////////////////////////
//////  read_remote_addr
/////////////////////////////////////
void read_remote_addr(char *stread, int indent)
{
  char temptext[50], temptext2[50];

  int spot_a, spot_b;

  char tempstr[256];
  int v_loop;
  int loop=0;
  int loop2=0;
  int loop3=0;
  int loop4=0;

  char d_a_f[30];

  loop=indent;
  do{
    if( stread[loop] != ')' && stread[loop] != '['){
       tempstr[loop2]=stread[loop];
       loop++;
       loop2++;
    }
  }while ( stread[loop] != ')' && stread[loop] != '[' );
  tempstr[loop2]='\0';

  for(v_loop=0;v_loop<256;v_loop++){
    if( strcmp(tempstr,variable_names[v_loop])==0) break;
  }
  sprintf(temptext,"%s",getenv("REMOTE_ADDR") );
  strcpy(value_of_variables[v_loop],temptext);

  if (stread[loop] == '['){    // [a .. b]
                               // [a .. bb]
                               // [aa .. bb]
    if(stread[loop+2]==' '){
      sprintf(d_a_f,"%c",stread[loop+1]);
    }
    else{
      sprintf(d_a_f,"%c%c",stread[loop+1],stread[loop+2]);
    }
      spot_a=atoi(d_a_f);
      spot_a--;

    if(stread[loop+2]==' ' && stread[loop+7]==']'){
      sprintf(d_a_f,"%c",stread[loop+6]);
    }
    if(stread[loop+2]==' ' && stread[loop+7]!=']'){
      sprintf(d_a_f,"%c%c",stread[loop+6],stread[loop+7]);
    }
    if(stread[loop+2]!=' ' && stread[loop+7]==']'){
      sprintf(d_a_f,"%c%c",stread[loop+7],stread[loop+8]);
    }

    spot_b=atoi(d_a_f);
    spot_b--;
    for(loop3=spot_a;loop3<=spot_b;loop3++){
      temptext2[loop4]=temptext[loop3];
      loop4++;
    }
    temptext2[loop4]='\0';
    strcpy(value_of_variables[v_loop],temptext2);
  }
}

